import {constants} from 'http2';
import http from 'http';
import {HttpMiddlewareError} from '../server';

interface RequestContext extends http.IncomingMessage {
	method: string;
}

export const adjustMethod = (req: RequestContext) => {
	if (!req.method) {
		throw new HttpMiddlewareError('methodNotAllowed', {
			statusCode: constants.HTTP_STATUS_METHOD_NOT_ALLOWED,
			headers: {
				'Allow': 'HEAD, GET, POST, PUT, PATCH, DELETE',
			},
		});
	}

	req.method = req.method.trim().toUpperCase();
};
