import {constants} from 'http2';
import http from 'http';
import {HttpMiddlewareError} from '../server';

interface RequestContext extends http.IncomingMessage {
	basePath?: string;

	query?: URLSearchParams;

	rawUrl: string;
}

export const adjustUrl = (req: RequestContext) => {
	if (!req.url) {
		throw new HttpMiddlewareError('badRequest', {
			statusCode: constants.HTTP_STATUS_BAD_REQUEST,
		});
	}

	const theBasePathUrl = req.basePath ?? '';
	const basePath = new URL(theBasePathUrl, 'http://localhost');
	const parsedUrl = new URL(`${theBasePathUrl}/${req.url}`, 'http://localhost');
	req.rawUrl = req.url;
	req.url = req.url.slice(basePath.pathname.length);
	req.query = parsedUrl.searchParams;
	return;
};
